/*
 *     EventSource.java  Dec 3, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.event;
import java.util.*;

public class EventSource {
    protected ArrayList warningListeners = new ArrayList();  //  WarningEventListener
    protected ArrayList logListeners = new ArrayList();      //  LogEventListener
    protected ArrayList noticeListeners = new ArrayList();   //  NoticeEventListener

    protected EventSource() {
    }

    public boolean addEventListener(WarningEventListener l) {
        return warningListeners.add(l);
    }

    public boolean addEventListener(LogEventListener l) {
        return logListeners.add(l);
    }

    public boolean addEventListener(NoticeEventListener l) {
        return noticeListeners.add(l);
    }

    public boolean removeEventListener(WarningEventListener l) {
        return warningListeners.remove(l);
    }

    public boolean removeEventListener(LogEventListener l) {
        return logListeners.remove(l);
    }

    public boolean removeEventListener(NoticeEventListener l) {
        return noticeListeners.remove(l);
    }

    public void fire(WarningEvent evt) {
        if (warningListeners.size() == 0) {
            System.out.println(evt.getMessage());
            return;
        }

        Iterator it = warningListeners.iterator();
        while (it.hasNext()) {
            WarningEventListener l = (WarningEventListener)it.next();
            l.printMessage(evt);
        }
    }

    public void fire(LogEvent evt) {
        if (logListeners.size() == 0) {
            System.out.println(evt.getMessage());
            return;
        }

        Iterator it = logListeners.iterator();
        while (it.hasNext()) {
            LogEventListener l = (LogEventListener)it.next();
            l.printMessage(evt);
        }
    }

    public void fire(NoticeEvent evt) {
        if (noticeListeners.size() == 0) {
            System.out.println(evt.getMessage());
            return;
        }

        Iterator it = noticeListeners.iterator();
        while (it.hasNext()) {
            NoticeEventListener l = (NoticeEventListener)it.next();
            l.printMessage(evt);
        }
    }
}
