/*
 *     CutCopyPasteMenu.java  Dec 3, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.gui;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

public class CutCopyPasteMenu implements PopupMenuListener {
    private FileManager fileManager;
    private JMenuItem cutItem;
    private JMenuItem copyItem;
    private JMenuItem pasteItem;

    public CutCopyPasteMenu(JComponent menu, FileManager fm) {
        fileManager = fm;
        init(menu);
    }

    private void init(JComponent menu) {
        cutItem = new JMenuItem("Cut", 'T');
        cutItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                CodePane codePane = fileManager.getCurrentCodePane();
                codePane.cut();
            }
        });

        copyItem = new JMenuItem("Copy", 'C');
        copyItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                CodePane codePane = fileManager.getCurrentCodePane();
                codePane.copy();
            }
        });

        pasteItem = new JMenuItem("Paste", 'P');
        pasteItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                CodePane codePane = fileManager.getCurrentCodePane();
                codePane.paste();
            }
        });
        pasteItem.setEnabled(false);

        menu.add(cutItem);
        menu.add(copyItem);
        menu.add(pasteItem);
    }

    public void updateMenuState() {
        CodePane codePane = fileManager.getCurrentCodePane();
        cutItem.setEnabled(codePane.isSelected());
        copyItem.setEnabled(codePane.isSelected());
        pasteItem.setEnabled(codePane.canPasteAction());
    }

    public void popupMenuWillBecomeVisible(PopupMenuEvent evt) {
    }

    public void popupMenuWillBecomeInvisible(PopupMenuEvent evt) {
        CodePane codePane = fileManager.getCurrentCodePane();
        codePane.hideCursor();
    }

    public void popupMenuCanceled(PopupMenuEvent evt) {
    }
}
