/*
 *     CygwinPathDialog.java  May 5, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.gui;
import javax.swing.*;
import java.io.File;

public class CygwinPathDialog extends PropertyDialog {

    public CygwinPathDialog(SimpleBrowser browser) {
        this(browser, null);
    }

    public CygwinPathDialog(SimpleBrowser browser, String mesg) {
        super(browser, "Cygwin Path", mesg, JFileChooser.DIRECTORIES_ONLY);
    }

    protected boolean checkOption(String name) {
        File file = new File(name);
        if (file.isDirectory()) {
            return true;
        }
        JOptionPane.showMessageDialog(frame, "Failed to find: " + name + ".");
        return false;
    }

    public void show() {
        super.show();

        browser.setCygwinDir(propertyField.getText());
    }
}
