/*
 *     LogPane.java  Dec 2, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.gui;
import org.jtool.platform.event.*;
import javax.swing.*;
import java.awt.*;
import java.sql.Timestamp;

public class LogPane extends JScrollPane implements LogEventListener {
    private JFrame frame;
    private JTextArea textArea;

    public LogPane(JFrame frame) {
        super();
        this.frame = frame;
        createPane();
    }

    private void createPane() {
        Font font = new Font("Dialog", Font.PLAIN, 12);
        textArea = new JTextArea();
        textArea.setText("");
        textArea.setEditable(false);
        textArea.setFont(font);
        textArea.setBackground(Color.white);
        textArea.setMargin(new Insets(5, 5, 5, 5));
        textArea.setRows(5);

        setViewportView(textArea);
        setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    }

    public void setText(String text) {
        textArea.setText(text);
    }

    public void printMessage(LogEvent evt) {
        Timestamp timestamp = new Timestamp(System.currentTimeMillis());
        textArea.append(evt.getMessage());        
        textArea.append("  ");
        textArea.append(timestamp.toString());
        textArea.append("\n");
    }
}
