/*
 *     ParsingMonitor.java  Dec 3, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.gui;
import org.jtool.platform.j2xml.Repository;
import org.jtool.platform.event.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class ParsingMonitor extends JDialog implements NoticeEventListener {
    private JFrame frame;
    private Container contentPane;
    private JOptionPane optionPane;
    private JLabel noteLabel;
    private ArrayList changedTexts;

    public ParsingMonitor(JFrame frame, String mesg) {
        super(frame, "Progress...", true);
        this.frame = frame;

        createPanes(mesg);
    }

    private void createPanes(String mesg) {
        contentPane = this.getContentPane();
        contentPane.setLayout(new BorderLayout());

        noteLabel = new JLabel();

        Object[] message = new Object[2];
        message[0] = mesg;
        message[1] = noteLabel;

        Object[] options = new Object[0];
       
        optionPane = new JOptionPane(message,
          JOptionPane.INFORMATION_MESSAGE, JOptionPane.DEFAULT_OPTION, null, options);
        contentPane.add(optionPane, "Center");

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
            }
        });

        pack();
        setSize(800, 120);
        setLocationRelativeTo(frame);
        validate();
    }

    private void setNote(String note) {
        noteLabel.setText(note);
    }

    private void close() {
        Repository.removeEventListener(this);
        setVisible(false);
        dispose();
    }

    public void setChangedTexts(ArrayList texts) {
        changedTexts = texts;
    }

    public ArrayList getChangedTexts() {
        return changedTexts;
    }

    public void printMessage(NoticeEvent evt) {
        String mesg = evt.getMessage();
        setNote(mesg);
        System.out.println(mesg);
    }

    public void start(final ArrayList files) {
        Repository.addEventListener(this);
        setNote("Checking files....");

        Thread parser = new Thread() {
            public void run() {
                ArrayList texts = Repository.parse(files);

                Iterator it = files.iterator();
                setChangedTexts(texts);
                close();
            }
        };
        parser.start();
        setVisible(true);
    }
}
