/*
 *     ProjectPathDialog.java  Apr 2, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.gui;
import javax.swing.*;
import java.io.File;

public class ProjectPathDialog extends PropertyDialog {

    public ProjectPathDialog(SimpleBrowser browser) {
        this(browser, null);
    }

    public ProjectPathDialog(SimpleBrowser browser, String mesg) {
        super(browser, "Project Path", mesg, JFileChooser.DIRECTORIES_ONLY);
    }

    public ProjectPathDialog(MainFrame frame, FileManager fm) {
        this(frame, fm, null);
    }

    public ProjectPathDialog(MainFrame frame, FileManager fm, String mesg) {
        super(frame, fm, "Project Path", mesg, JFileChooser.DIRECTORIES_ONLY);
    }

    protected boolean checkOption(String name) {
        File file = new File(name);
        if (file.isDirectory()) {
            return true;
        }
        JOptionPane.showMessageDialog(frame, "Failed to find: " + name + ".");
        return false;
    }

    public void show() {
        propertyField.setText(browser.getProjectDir());
        super.show();

        String oldDir = browser.getProjectDir();
        String newDir = propertyField.getText();
        browser.changeProject(newDir);

        setVisible(false);
        if (frame != null && oldDir != null && !oldDir.equals(newDir)) { 
            fileManager.buildFileTree(newDir);
        }
    }
}
