/*
 *     SapidPathDialog.java  Jan 21, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.gui;
import javax.swing.*;
import java.io.File;

public class SapidPathDialog extends PropertyDialog {

    public SapidPathDialog(SimpleBrowser browser) {
        this(browser, null);
    }

    public SapidPathDialog(SimpleBrowser browser, String mesg) {
        super(browser, "Sapid Path", mesg, JFileChooser.DIRECTORIES_ONLY);
    }

    protected boolean checkOption(String name) {
        File file = new File(name);
        if (file.isDirectory()) {
            return true;
        }
        JOptionPane.showMessageDialog(frame, "Failed to find: " + name + ".");
        return false;
    }

    public void show() {
        super.show();

        browser.setSapidDir(propertyField.getText());
    }
}
