/*
 *     AccessibleChecker.java  Aug 4, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.j2xml;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;

public class AccessibleChecker {

    public static boolean isAccessible(JavaClass jc, JavaField jf) {
        JavaClass c = jf.getJavaClass();

        if (jc.equals(c) || jf.isPublic()) {
            return true;
        }

        JavaClassList ancestors = AncestorResolver.getAncestors(jc);
        if (jf.isProtected() && ancestors.contains(c)) {
            return true;
        }

        if (!jf.isPrivate() && jc.isInTheSamePackage(c)) {
           return true;
        }

        return false;
    }

    public static boolean isAccessible(JavaClass jc, JavaMethod jm) {
        JavaClass c = jm.getJavaClass();

        if (jc.equals(c) || jm.isPublic()) {
            return true;
        }

        if (!jm.isPrivate() && jc.isInTheSamePackage(c)) {
            return true;
        }
        
        JavaClassList ancestors = AncestorResolver.getAncestors(jc);
        if (jm.isProtected() && ancestors.contains(c)) {
            return true;
        }

        return false;
    }
}
