/*
 *     LineResolver.java  Jan 19, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.j2xml;
import org.jtool.platform.xml.*;
import org.w3c.dom.*;

public class LineResolver extends SimpleResolver {
    private static int lineNum;

    public static Document run(JavaXMLText text) {
        return run(text.getDocument());
    }

    public static Document run(Document doc) {
        lineNum = 1;

        Node node = doc.getDocumentElement();
        traverseNode(node);

        return doc;
    }

    private static void traverseNode(Node node) {
        if (node.getNodeType() == Node.ELEMENT_NODE) {

            String id = getAttributeValue(node, JXConstants.IdAttr);
            if (id != null) {
                Element elem = (Element)node;
                elem.setAttribute(JXConstants.LineAttr, String.valueOf(lineNum));
            }

            if (node.getNodeName().equals(JXConstants.NewLineElem)) {
                String line = getAttributeValue(node, JXConstants.LineAttr);
                if (line != null) {
                    lineNum = Integer.parseInt(line) + 1;
                }
            }

            NodeList nl = node.getChildNodes();
            for (int i = 0; i < nl.getLength(); i++) {
                Node child = nl.item(i);
                traverseNode(child);
            }
        }
    }

    private static String getAttributeValue(Node node, String attrStr) {
        NamedNodeMap attrs = node.getAttributes();
        for (int i = 0; i < attrs.getLength(); i++) {
            Node attr = attrs.item(i);
            if (attr.getNodeName().equals(attrStr)) {
                return attr.getNodeValue();
            }
        }
        return null;
    }
}
