/*
 *     SimpleResolver.java  Nov 12, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.j2xml;
import java.util.*;
import org.w3c.dom.*;

public class SimpleResolver {

    protected static void removeChildNodes(Node node) {
        while (node.hasChildNodes()) {
            node.removeChild(node.getFirstChild());
        }
    }

    protected static void removeChildNodes(Node node, String name) {
        NodeList nl = node.getChildNodes();
        ArrayList nodes = new ArrayList();
        for (int i = 0; i < nl.getLength(); i++) {
            if (nl.item(i).getNodeName().equals(name)) {
                nodes.add(nl.item(i));
            }
        }

        Iterator it = nodes.iterator();
        while (it.hasNext()) {
            node.removeChild((Node)it.next());
        }
    }

    protected static Node appendTextChildNode(Document doc, Node node, String text) {
        Node tnode = doc.createTextNode(text);
        node.appendChild(tnode);
        return tnode;
    }

    protected static Node appendElemChildNode(Document doc, Node node, String name) {
        Node enode = doc.createElement(name);
        node.appendChild(enode);
        return enode;
    }

    protected static void replaceChild(Node newNode, Node oldNode) {
        Node parent = oldNode.getParentNode();
        parent.replaceChild(newNode, oldNode);
    }

    protected static void replaceChildNodes(Node newNode, Node oldNode) {
        ArrayList nodes = new ArrayList();
        NodeList nl = oldNode.getChildNodes();
        for (int i = 0; i < nl.getLength(); i++) {
            Node child = nl.item(i);
            nodes.add(child);
        }

        Iterator it = nodes.iterator();
        while (it.hasNext()) {
            Node child = (Node)it.next();
            newNode.appendChild(child);
        }
        Node parent = oldNode.getParentNode();
        parent.replaceChild(newNode, oldNode);
    }
}
