/*
 *     TypeConversion.java  Jan 28, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.j2xml;

public class TypeConversion {

    public static String getLiteralType(String sort) {
        if (sort.equals("NULL")) {
            return "null";
        } else if (sort.equals("INT")) {
            return "int";
        } else if (sort.equals("FLOAT")) {
            return "float";
        } else if (sort.equals("CHAR")) {
            return "char";
        } else if (sort.equals("BOOL")) {
            return "boolean";
        } else if (sort.equals("STR")) {
            return "java.lang.String";
        }
        return sort;
    }

    public static String wideningTypeInExpr(String type1, String type2) {
        if (type1.equals("java.lang.String") || type2.equals("java.lang.String")) {
            return "java.lang.String";
        } else {
            return wideningPrimitiveType(type1, type2);
        } 
    }

    public static String wideningPrimitiveType(String type1, String type2) {
        if (type1.equals("double") || type2.equals("double")) {
            return "double";
        } else if (type1.equals("float") || type2.equals("float")) {
            return "float";
        } else if (type1.equals("long") || type2.equals("long")) {
            return "long";
        } else if (type1.equals("int") || type2.equals("int")) {
            return "int";
        } else if (type1.equals("char") || type2.equals("char")) {
            return "char";
        } else if (type1.equals("short") || type2.equals("short")) {
            return "short";
        } else if (type1.equals("byte") || type2.equals("byte")) {
            return "short";
        }
        return type2;
    }

    public static boolean isPrimitiveType(String type) {
        if (type.equals("void") ||
            type.equals("byte") ||
            type.equals("char") ||
            type.equals("int") ||
            type.equals("short") ||
            type.equals("long") ||
            type.equals("float") ||
            type.equals("double") ||
            type.equals("boolean")) {
            return true;
        }
        return false;
    }
}
