/*
 *     DOM2Code.java  Mar 27, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.dom;
import org.w3c.dom.*;

public class DOM2Code {
    private static StringBuffer buf;

    public static String getCode(Document doc) {
        buf = new StringBuffer();
        writeNode(doc.getDocumentElement());
        return buf.toString();
    }

    public static String getCode(Node node) {
        buf = new StringBuffer();
        writeNode(node);
        return buf.toString();
    }

    private static void writeNode(Node node) {
        if (node.getNodeType() == Node.TEXT_NODE) {
            buf.append(node.getNodeValue());

        } else if (node.getNodeType() == Node.ELEMENT_NODE) {
            for (Node child = node.getFirstChild();
                 child != null; child = child.getNextSibling()) {
                writeNode(child);
            }
        }
    }

    private static int elemNum;
    private static int attrNum;

    public static void initNum() {
        elemNum = 0;
        attrNum = 0;
    }

    public static void termNum() {
        System.out.println("ELEM = " + elemNum);
        System.out.println("ATTR = " + attrNum);
    }

    public static void visitNode(Document doc) {
        visitNode(doc.getDocumentElement());
    }

    private static void visitNode(Node node) {
        elemNum++;
        if (node.getNodeType() == Node.ELEMENT_NODE) {

            NamedNodeMap attrs = node.getAttributes();
            for (int i = 0; i < attrs.getLength(); i++) {
                
                Node attr = attrs.item(i);
                attrNum++;
            }

            for (Node child = node.getFirstChild();
                 child != null; child = child.getNextSibling()) {
                visitNode(child);
            }
        }
    }
}
