/*
 *     GetElem.java  Nov 24, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.dom;
import org.jtool.platform.xml.JXConstants;
import org.w3c.dom.*;

public class GetElem {
    private static Element foundElem;

    public static Element getElem(Document doc, String id) {
        foundElem = null;
        findElem(doc.getDocumentElement(), id);
        return foundElem;
    }

    private static void findElem(Element elem, String id) {
        if (elem.getAttribute(JXConstants.IdAttr).equals(id)) {
            foundElem = elem;
            return;
        }

        NodeList nl = elem.getChildNodes();
        for (int i = 0; i < nl.getLength(); i++) {
            Node child = nl.item(i);
            if (child.getNodeType() == Node.ELEMENT_NODE) {
                findElem((Element)child, id);
            }
        }
    }
}
