/*
 *     NullElement.java  Jun 19, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.dom;
import org.w3c.dom.*;

public class NullElement extends NullNode implements Element {
    private static final String name = "NullElement";

    public NullElement() {
    }

    public String getTagName() {
        return name;
    }

    public String getAttribute(String name) {
        return "";
    }

    public void setAttribute(String name, String value) {
    }

    public void removeAttribute(String name) {
    }

    public Attr getAttributeNode(String name) {
        return new NullAttr();
    }
    
    public Attr setAttributeNode(Attr newAttr) {
        return newAttr;
    }

    public Attr removeAttributeNode(Attr oldAttr) {
        return oldAttr;
    }

    public NodeList getElementsByTagName(String name) {
        return new NullNodeList();
    }

    public String getAttributeNS(String namespaceURI,  String localName) {
        return name;
    }

    public void setAttributeNS(String namespaceURI, String qualifiedName, String value) {
    }

    public void removeAttributeNS(String namespaceURI, String localName) {
    }

    public Attr getAttributeNodeNS(String namespaceURI, String localName) {
        return new NullAttr();
    }

    public Attr setAttributeNodeNS(Attr newAttr) {
        return newAttr;
    }

    public NodeList getElementsByTagNameNS(String namespaceURI, String localName) {
        return new NullNodeList();
    }

    public boolean hasAttribute(String name) {
        return false;
    }

    public boolean hasAttributeNS(String namespaceURI, String localName) {
        return false;
    }
}
