/*
 *     NullNamedNodeMap.java  Jan 19, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.dom;
import org.w3c.dom.*;

public class NullNamedNodeMap implements NamedNodeMap {
    private static final int length = 0;

    public NullNamedNodeMap() {
    }

    public Node getNamedItem(String name) {
        return NullNode.getInstance();
    }

    public Node setNamedItem(Node arg) {
        return NullNode.getInstance();
    }

    public Node removeNamedItem(String name) {
        return NullNode.getInstance();
    }
    public Node item(int index) {
        return NullNode.getInstance();
    }

    public int getLength() {
        return length;
    }

    public Node getNamedItemNS(String namespaceURI, String localName) {
        return NullNode.getInstance();
    }

    public Node setNamedItemNS(Node arg) {
        return NullNode.getInstance();
    }

    public Node removeNamedItemNS(String namespaceURI, String localName) {
        return NullNode.getInstance();
    }
}
