/*
 *     NullNode.java  Jan 19, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.dom;
import org.w3c.dom.*;

public class NullNode implements Node {
    private static final NullNode node = new NullNode();
    public static final short NULL_NODE = 255;
    private static final String name = "";

    protected NullNode() {
    }

    public static NullNode getInstance() {
        return node;
    }

    public String getNodeName() {
        return name;
    }

    public String getNodeValue() {
        return name;
    }

    public void setNodeValue(String nodeValue) {
    }

    public short getNodeType() {
        return NULL_NODE;
    }

    public Node getParentNode() {
        return node;
    }

    public NodeList getChildNodes() {
        return new NullNodeList();
    }

    public Node getFirstChild() {
        return node;
    }

    public Node getLastChild() {
        return node;
    }

    public Node getPreviousSibling() {
        return node;
    }

    public Node getNextSibling() {
        return node;
    }

    public NamedNodeMap getAttributes() {
        return new NullNamedNodeMap();
    }

    public Document getOwnerDocument() {
        System.err.println("Forbid to call this method!");
        return null;
    }

    public Node insertBefore(Node newChild, Node refChild) {
        return node;
    }

    public Node replaceChild(Node newChild, Node oldChild) {
        return node;
    }

    public Node removeChild(Node oldChild) {
        return node;
    }

    public Node appendChild(Node newChild) {
        return node;
    }

    public boolean hasChildNodes() {
        return false;
    }

    public Node cloneNode(boolean deep) {
        return node;
    }

    public void normalize() {
    }

    public boolean isSupported(String feature, String version) {
        return false;
    }

    public String getNamespaceURI() {
        return name;
    }

    public String getPrefix() {
        return name;
    }

    public void setPrefix(String prefix) {
    }

    public String getLocalName() {
        return name;
    }
     
    public boolean hasAttributes() {
        return false;
    }
}
