/*
 *     GraphEdge.java  Dec 18, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.graph;

public class GraphEdge implements GraphComp, GraphEdgeSort {
    protected GraphNode src;
    protected GraphNode dst;
    protected int sort;

    protected GraphEdge() {
    }

    public GraphEdge(GraphNode src, GraphNode dst) {
        this.src = src;
        this.dst = dst;
        src.addOutgoingEdge(this);
        dst.addIncomingEdge(this);
    }

    public boolean equals(GraphComp comp) {
        GraphEdge edge = (GraphEdge)comp;
        if (this == edge) {
            return true;
        }
        return src.equals(edge.getSrcNode()) && dst.equals(edge.getDstNode());
    }

    public int getSort() {
        return sort;
    }

    public void setSrcNode(GraphNode node) {
        src.removeOutgoingEdge(this);
        src = node;
        src.addOutgoingEdge(this);
    }

    public void setDstNode(GraphNode node) {
        dst.removeIncomingEdge(this);        
        dst = node;
        dst.addIncomingEdge(this);
    }

    public GraphNode getSrcNode() {
        return src;
    }

    public GraphNode getDstNode() {
        return dst;
    }

    public void print(StringBuffer buf) {
        buf.append(src.getId() + " -> " + dst.getId());
    }

    public void write(StringBuffer buf) {
    }
}
