/*
 *     GraphNodeSort.java  Aug 12, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.graph;

public interface GraphNodeSort {
    public static final int entries          = 1;
    public static final int classEntry       = 11;  // JXConstants.ClassElem
    public static final int interfaceEntry   = 12;  // JXConstants.InterfaceElem
    public static final int methodEntry      = 13;  // JXConstants.MethodElem
    public static final int constructorEntry = 14;  // JXConstants.ConstructorElem

    public static final int exits            = 2;
    public static final int classExit        = 21;   // JXConstants.ClassElem
    public static final int interfaceExit    = 22;   // JXConstants.InterfaceElem
    public static final int methodExit       = 23;   // JXConstants.MethodElem
    public static final int constructorExit  = 24;   // JXConstants.ConstructorElem

    public static final int callings         = 3;
    public static final int methodCall       = 31;  // JXConstants.ExpressionElem:MethodCall
    public static final int constructorCall  = 32;  // JXConstants.ExpressionElem:ConstructorCall
    public static final int instanceCreation = 33;  // JXConstants.ExpressionElem:InstanceCreation
    public static final int polymorphicCall  = 34;  

    public static final int parameters       = 4;
    public static final int formalIn         = 41;  // JXConstants.ParameterElem
    public static final int formalOut        = 42;  // JXConstants.ParameterElem
    public static final int actualIn         = 43;  // JXConstants.ASTArguments
    public static final int actualOut        = 44;  // JXConstants.ASTArguments

    public static final int assignments      = 5;
    public static final int assignmentSt     = 51;  // JXConstants.ExpressionElem:Assign
    public static final int fieldDecl        = 52;  // JXConstants.FieldElem
    public static final int localDecl        = 53;  // JXConstants.LocalElem
    public static final int newSt            = 54;  // JXConstants.ExpressionElem:InstanceCreation
    public static final int returnSt         = 55;  // JXConstants.StatementElem:Return

    public static final int branches         = 6;
    public static final int ifSt             = 61;  // JXConstants.StatementElem:If
    public static final int whileSt          = 62;  // JXConstants.StatementElem:While
    public static final int doSt             = 63;  // JXConstants.StatementElem:Do
    public static final int forSt            = 64;  // JXConstants.StatementElem:For
    public static final int breakSt          = 65;  // JXConstants.StatementElem:Break
    public static final int continueSt       = 66;  // JXConstants.StatementElem:Continue
    public static final int switchSt         = 67;  // JXConstants.StatementElem:Switch
    public static final int caseLabel        = 68;  // JXConstants.LabelElem
    public static final int defaultLabel     = 69;  // JXConstants.LabelElem
    public static final int throwSt          = 70;  // JXConstants.StatementElem:Throw
    public static final int synchronizedSt   = 71;  // JXConstants.StatementElem:Syncronized
    public static final int trySt            = 72;  // JXConstants.StatementElem:Try

    public static final int ignores          = 9;   // ignored in PDGs.
    public static final int labelSt          = 91;  // JXConstants.LabelElem
    public static final int mergeSt          = 92;
}
