/*
 *     CFGBreakContinue.java  Aug 17, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.graph.cfg;
import org.jtool.platform.xml.graph.*;
import org.w3c.dom.*;

public class CFGBreakContinue extends CFGBranch {
    private String label;
    private CFGNode target;

    private CFGBreakContinue() {
    }

    public CFGBreakContinue(int sort, Element elem) {
        super(sort, elem);
    }

    public CFGBreakContinue(int sort, Element elem, String label, CFGNode target) {
        this(sort, elem);
        this.label = label;
        this.target = target;
    }

    public String getLabel() {
        return label;
    }

    public CFGNode getTargetNode() {
        return target;
    }

    public void print(StringBuffer buf) {
        String mesg = "";
        switch (sort) {
            case GraphNodeSort.breakSt: mesg = "break"; break;
            case GraphNodeSort.continueSt: mesg = "continue"; break;
        }
        printDefUse(mesg, buf);
    }
}
