/*
 *     CFGMethodEntry.java  Aug 17, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.graph.cfg;
import org.jtool.platform.xml.graph.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import org.w3c.dom.Element;

public class CFGMethodEntry extends CFGNode {
    private ArrayList formalIns = new ArrayList();   // CFGParameter
    private ArrayList formalOuts = new ArrayList();  // CFGParameter

    protected CFGMethodEntry() {
    }

    public CFGMethodEntry(int sort, Element elem) {
        super(sort, elem);
    }

    public boolean isMethodEntry() {
        return true;
    }

    public void addFormalIn(CFGParameter node) {
        formalIns.add(node);
    }

    public ArrayList getFormalIns() {
        return new ArrayList(formalIns);
    }

    public void addFormalOut(CFGParameter node) {
        formalOuts.add(node);
    }

    public ArrayList getFormalOuts() {
        return new ArrayList(formalOuts);
    }

    public ArrayList getParameters() {
        return new ArrayList(formalIns);
    }

    public int getNumParameter() {
        return formalIns.size();
    }

    public CFGParameter getFormalIn(int i) {
        return (CFGParameter)formalIns.get(i); 
    }

    public CFGParameter getFormalOut(int i) {
        return (CFGParameter)formalOuts.get(i); 
    }

    public boolean hasParameters() {
        return formalIns.size() != 0;
    }

    public void print(StringBuffer buf) {
        String mesg = "";
        switch (sort) {
            case GraphNodeSort.methodEntry: mesg = "method entry"; break;
            case GraphNodeSort.constructorEntry:  mesg = "constructor entry"; break;
        }
        JavaMethod jm = new JavaMethod(elem);
        mesg = mesg + " [" + jm.getName() + "]";
        print(mesg, buf);
    }
}
