/*
 *     JavaSpecialVar.java  Dec 18, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.graph.cfg;
import org.jtool.platform.xml.wrapper.JavaVariable;
import org.w3c.dom.*;

public class JavaSpecialVar extends JavaVariable {
    private String name;
    private String type;

    private JavaSpecialVar() {
    }

    public JavaSpecialVar(Node node) {
        this(node, null, null);
    }

    public JavaSpecialVar(Node node, String name) {
        this(node, name, null);
    }

    public JavaSpecialVar(Node node, String name, String type) {
        super(node);
        this.name = name;
        this.type = type;
    }

    public String getName() {
        return name;
    }

    public String getType() {
        return type;
    }

    public boolean equals(JavaSpecialVar jv) {
        return jv == this || getName().equals(jv.getName());
    }
}
