/*
 *     GetPostDominator.java  Dec 18, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.graph.pdg;
import org.jtool.platform.xml.graph.*;
import org.jtool.platform.xml.graph.cfg.*;
import java.util.Iterator;

public class GetPostDominator {
    private GraphCompSet postDominator = new GraphCompSet();  // CFGNode
    private GraphCompSet track = new GraphCompSet();          // CFGNode

    private GetPostDominator() {
    }

    public GetPostDominator(CFG cfg, CFGNode anchor) {
        Iterator it = cfg.getNodes().iterator();
        while (it.hasNext()) {
            CFGNode node = (CFGNode)it.next();
            if (!anchor.equals(node)) {
                track.clear();
                track = cfg.getForwardReachableNodes(anchor, node);
                
                if (track.contains(node) && !track.contains(cfg.getEndNode())) {
                    postDominator.add(node);
                }
            }
        }
    }

    public boolean add(CFGNode node) {
        return postDominator.add(node);
    }

    public boolean contains(CFGNode node) {
        return postDominator.contains(node);
    }

    public boolean isEmpty() {
        return postDominator.isEmpty();
    }

    public Iterator iterator() {
        return postDominator.iterator();
    }

    public void printNodes() {
        Iterator it = postDominator.iterator();
        while (it.hasNext()) {
            CFGNode node = (CFGNode)it.next();
            node.print();
        }
    }
}
