/*
 *     WritePDG.java  Dec 15, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 *     
 *     Thanks to Daichi Oohashi who provides a patch so as to
 *     write well-formed XML.
 */

package org.jtool.platform.xml.graph.pdg;
import org.jtool.platform.xml.graph.cfg.*;
import org.jtool.platform.xml.dom.*;
import org.jtool.platform.xml.wrapper.*;
import org.jtool.platform.util.*;
import org.jtool.platform.j2xml.SystemProperties;
import java.util.*;
import java.io.*;
import org.w3c.dom.*;

public class WritePDG {
    public static void main(String[] args) {
        if (args.length == 1) {
            try {
                String fileName = SystemProperties.getCanonicalPath(args[0]);
                String text = ReadFile.read(fileName);
                Document doc = DOMTreeCreator.create(text);
                JavaFile jfile = new JavaFile(doc.getDocumentElement());

                Iterator it = jfile.getClassNodes().iterator();
                while (it.hasNext()) {
                    JavaClass jc = new JavaClass((Node)it.next());

                    StringBuffer buf = new StringBuffer();
                    buf.append("<?xml version=\"1.0\"?>\n");
                    makePDG(jc.getConstructorNodes(), buf);
                    makePDG(jc.getMethodNodes(), buf);

                    System.out.println(buf);
                }
            } catch (IOException e) { }
                
        } else {
            System.err.println("Usage: java WritePDG xml_filename");
        }
    }

    private static void makePDG(ArrayList methods, StringBuffer buf) {
        buf.append("<PDGs>\n");

        Iterator it = methods.iterator();
        while (it.hasNext()) {
            try {
                CFG cfg = new CFG((Node)it.next());
                PDG pdg = new PDG(cfg);
                buf.append(pdg.write());
            } catch (CFGException e) {
                System.err.println(e.getMessage());
            }
        }

        buf.append("</PDGs>\n");
    }
}
