/*
 *     JavaConstructorCall.java  Jan 30, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.wrapper;
import org.jtool.platform.xml.JXConstants;
import org.jtool.platform.xml.dom.*;
import org.w3c.dom.*;

public class JavaConstructorCall extends JavaCall {

    protected JavaConstructorCall() {
    }

    public JavaConstructorCall(Node node) {
        super(node);
    }

    public String getName() {
        if (name == null) {
            Element e = (Element)getFirstChildNode(elem, JXConstants.TypeElem);
            name = getIdentName(e);
        }
        return name;
    }

    public String getTypeFqn() {
        Element e = (Element)getFirstChildNode(elem, JXConstants.TypeElem);
        String fqn = e.getAttribute(JXConstants.FqnAttr);
        if (fqn.length() != 0) {
            return fqn;
        }
        return "";
    }
}
