/*
 *     JavaParameter.java  Aug 6, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.wrapper;
import org.jtool.platform.xml.JXConstants;
import org.w3c.dom.*;

public class JavaParameter extends JavaLocal {

    protected JavaParameter() {
    }

    public JavaParameter(Node node) {
        super(node);
    }

    public String getName() {
        if (name == null) {
            name = getIdentName(elem);
        }
        return name;
    }

    public Node getIdentNode() {
        return getFirstChildNode(elem, JXConstants.IdentElem);
    }

    public boolean equals(JavaParameter jp) {
        return jp != null && isInTheSameMethod(jp) && getName().equals(jp.getName());
    }

    public boolean isParameter() {
        return true;
    }

    public boolean isFinal() {
        return elem.getAttribute(JXConstants.FinalAttr).equals(JXConstants.YES);
    }

    public boolean isLocal() {
        return false;
    }

    public void print(StringBuffer buf) {
        print("", buf);
    }

    public void print(String indent, StringBuffer buf) {
        buf.append(indent + "PARAM: " + getName());
        buf.append("@" + getType() + "[" + getTypeFqn() + "]\n");
    }        
}
