/*
 *     Project.java  Jan 30, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.xref;
import org.jtool.platform.j2xml.Repository;
import org.jtool.platform.j2xml.JavaXMLText;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import org.w3c.dom.*;

public class Project {

    public static ArrayList getAllPackages() {
        ArrayList names = new ArrayList();

        Iterator it = Repository.getJavaTexts().iterator();
        while (it.hasNext()) {
            JavaXMLText text = (JavaXMLText)it.next();

            Element elem = text.getDocument().getDocumentElement();
            JavaFile jf = new JavaFile(elem);
            if (jf != null) {
                if (!names.contains(jf.getPackageName())) {
                    names.add(jf.getPackageName());
                }
            }
        }
        return names;
    }

    public static ArrayList getAllFiles() {
        ArrayList files = new ArrayList();

        Iterator it = Repository.getJavaTexts().iterator();
        while (it.hasNext()) {
            JavaXMLText text = (JavaXMLText)it.next();

            Element elem = text.getDocument().getDocumentElement();
            JavaFile jf = new JavaFile(elem);
            if (jf != null) {
                files.add(jf);
            }
        }
        return files;
    }     

    public static ArrayList getAllFilesInPackage(String name) {
        ArrayList files = new ArrayList();

        Iterator it = Repository.getJavaTexts().iterator();
        while (it.hasNext()) {
            JavaXMLText text = (JavaXMLText)it.next();

            Element elem = text.getDocument().getDocumentElement();
            JavaFile jf = new JavaFile(elem);
            if (jf != null && jf.getPackageName().equals(name)) {
                files.add(jf);
            }
        }
        return files;
    }     

    public static JavaClassList getAllClasses() {
        JavaClassList classes = new JavaClassList();

        Iterator it = getAllFiles().iterator();
        while (it.hasNext()) {
            JavaFile jf = (JavaFile)it.next();
            classes.addAll(jf.getAllClasses());
        }
        return classes;
    }     

    public static JavaClassList getAllClassesInPackage(String name) {
        JavaClassList classes = new JavaClassList();

        Iterator it = getAllFilesInPackage(name).iterator();
        while (it.hasNext()) {
            JavaFile jf = (JavaFile)it.next();
            classes.addAll(jf.getAllClasses());
        }
        return classes;
    }     

    public static JavaClassList getAllInterfaces() {
        JavaClassList classes = new JavaClassList();

        Iterator it = getAllFiles().iterator();
        while (it.hasNext()) {
            JavaFile jf = (JavaFile)it.next();
            classes.addAll(jf.getAllInterfaces());
        }
        return classes;
    }     

    public static JavaClassList getAllInterfacesInPackage(String name) {
        JavaClassList classes = new JavaClassList();

        Iterator it = getAllFilesInPackage(name).iterator();
        while (it.hasNext()) {
            JavaFile jf = (JavaFile)it.next();
            classes.addAll(jf.getAllInterfaces());
        }
        return classes;
    }
}
