/*
 *     XrefJavaMethod.java  Dec 2, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.xref;
import java.util.*;
import org.w3c.dom.*;

public class XrefJavaMethod extends XrefJavaElement {

    private XrefJavaMethod() {
    }

    public XrefJavaMethod(Element elem) {
        super(elem);
    }

    public String getFqn() {
        return elem.getAttribute(Constants.FqnAttr);
    }

    public String getAccess() {
        return elem.getAttribute(Constants.AccessAttr);
    }

    public String getModifier() {
        return elem.getAttribute(Constants.ModifierAttr);
    }

    public String getSignature() {
        return getName();
    }

    public boolean isConstructor() {
        return elem.getNodeName().equals(Constants.ConstructorElem);
    }

    public ArrayList getThrowsNodes() {
        return getChildNodes(Constants.ThrowsElem);
    }

    public ArrayList getOverridingNodes() {
        return getChildNodes(Constants.OverridingElem);
    }

    public ArrayList getOverriddenNodes() {
        return getChildNodes(Constants.OverriddenElem);
    }

    public ArrayList getOverloadingNodes() {
        return getChildNodes(Constants.OverloadingElem);
    }

    public ArrayList getOverloadedNodes() {
        return getChildNodes(Constants.OverloadedElem);
    }

    public ArrayList getImplementingNodes() {
        return getChildNodes(Constants.ImplementingElem);
    }

    public ArrayList getImplementedNodes() {
        return getChildNodes(Constants.ImplementedElem);
    }

    public ArrayList getReferringNodes() {
        return getChildNodes(Constants.RefSourceElem);
    }
}
