/*
 *     XrefProject.java  Dec 2, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.xref;
import java.util.*;
import org.w3c.dom.*;

public class XrefProject extends XrefElement {

    private XrefProject() {
    }

    public XrefProject(Element elem) {
        super(elem);
    }

    public ArrayList getPackageNames() {
        ArrayList names = new ArrayList();

        Iterator it = getChildNodes(Constants.PackageElem).iterator();
        while (it.hasNext()) {
            Node node = (Node)it.next();
            Element elem = (Element)node;
            elem.getAttribute(Constants.IdAttr);

            names.add(elem.getAttribute(Constants.NameAttr));
        }
        return names;
    }

    public ArrayList getClassNodes() {
        return getDescendantNodes(Constants.ClassElem);
    }

    public ArrayList getInterfaceNodes() {
        return getDescendantNodes(Constants.InterfaceElem);
    }

    public ArrayList getFieldNodes() {
        return getDescendantNodes(Constants.FieldElem);
    }

    public ArrayList getConstructorNodes() {
        return getDescendantNodes(Constants.ConstructorElem);
    }

    public ArrayList getMethodNodes() {
        return getDescendantNodes(Constants.MethodElem);
    }
}
